/* Script generated by Pawn Studio */

#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <hamsandwich>
#include <engine>
#include <cstrike>

#define PLUGIN	"Silent Glock"
#define AUTHOR	"DarkGL"
#define VERSION	"1.0"

new const szModelGlockV[] = "models/v_glock18_silent.mdl";
new const szModelGlockP[] = "models/p_glock18_silent.mdl";
new const szSoundFirstShoot[] = "glock18-1_silent.wav";
new const szSoundSecondShoot[] = "glock18-2_silent.wav";

new const szModelGlockVDefault[] = "models/v_glock18.mdl";
new const szModelGlockPDefault[] = "models/p_glock18.mdl";

const XO_WEAPON = 4 
const m_pPlayer = 41
const m_flNextSecondaryAttack = 47;

new bool: silentGlock[ 33 ];

public plugin_init(){
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	RegisterHam(Ham_Item_Deploy, "weapon_glock18", "fwItemDeploy",1);
	
	RegisterHam( Ham_Weapon_PrimaryAttack, "weapon_glock18", "fwPrimaryAttack_Pre", false );
	RegisterHam( Ham_Weapon_SecondaryAttack, "weapon_glock18", "fwSecondaryAttack_Pre", false );
	
	RegisterHam( Ham_Item_Drop , "weapon_glock18" , "fwDrop" , true );
	
	RegisterHam( Ham_Killed , "player" , "fwKilled" , true );
	
	RegisterHam( Ham_RemovePlayerItem , "player" , "fwRemovePlayerItem" , false );
	
	register_forward( FM_UpdateClientData, "UpdateClientData_Post", true );
}

public plugin_precache(){
	precache_model( szModelGlockV );
	precache_model( szModelGlockP );
	
	precache_sound( szSoundFirstShoot );
	precache_sound( szSoundSecondShoot );
}

public client_connect( id ){
	silentGlock[ id ] = false;
}

public client_disconnect( id ){
	silentGlock[ id ] = false;
}

public fwItemDeploy(wpn){
	static iOwner;
	iOwner = pev(wpn,pev_owner);
	
	if( !is_user_alive( iOwner ) ){
		return HAM_IGNORED;
	}
	
	if( !silentGlock[ iOwner ] ){
		return HAM_IGNORED;
	}
	
	set_pev( iOwner,pev_viewmodel2, szModelGlockV );
	set_pev( iOwner,pev_weaponmodel2, szModelGlockP );
	
	return HAM_IGNORED;
}

public fwPrimaryAttack_Pre( iGlock ){
	if( !pev_valid( iGlock ) ){
		return HAM_IGNORED;
	}
	
	new iOwner = get_pdata_cbase( iGlock, m_pPlayer, XO_WEAPON );
	
	if( !is_user_alive( iOwner ) ){
		return HAM_IGNORED;
	}
	
	if( silentGlock[ iOwner ] ){
		emit_sound(iOwner , CHAN_STATIC , random_num( 0 , 1 ) == 0 ? szSoundFirstShoot : szSoundSecondShoot , 0.5, ATTN_NORM, 0, PITCH_NORM);
		
		setWeaponAnim( iOwner , 5 );
	}
	
	return HAM_IGNORED;
	
}

public fwSecondaryAttack_Pre( iGlock ){
	if( !pev_valid( iGlock ) ){
		return HAM_IGNORED;
	}
	
	new iOwner = get_pdata_cbase( iGlock, m_pPlayer, XO_WEAPON );
	
	if( !is_user_alive( iOwner ) ){
		return HAM_IGNORED;
	}
	
	if( silentGlock[ iOwner ] ){
		cs_set_weapon_burst( iGlock , 1 );
		
		set_pev( iOwner,pev_viewmodel2, szModelGlockVDefault );
		set_pev( iOwner,pev_weaponmodel2, szModelGlockPDefault );
		
		silentGlock[ iOwner ] = false;
		
		setWeaponAnim( iOwner , 8 );
		
		return HAM_IGNORED;
	}
	else if( cs_get_weapon_burst( iGlock ) == 1 ){
		silentGlock[ iOwner] = true;
		
		cs_set_weapon_burst( iGlock , 0 );
		
		client_print( iOwner , print_center , "Switched to Silent mode" );
		
		set_pev( iOwner,pev_viewmodel2, szModelGlockV );
		set_pev( iOwner,pev_weaponmodel2, szModelGlockP );
		
		set_pdata_float(iGlock, m_flNextSecondaryAttack, 0.25, XO_WEAPON);
		
		setWeaponAnim( iOwner , 8 );
		
		return HAM_SUPERCEDE;
	}
	
	return HAM_IGNORED;
}

public UpdateClientData_Post( id, sendweapons, cd_handle ){
	if ( !is_user_alive(id) ){
		return FMRES_IGNORED;
	}
	
	if( !silentGlock[ id ] ){
		return FMRES_IGNORED;
	}
	
	if( get_user_weapon(id ) != CSW_GLOCK18 ){
		return FMRES_IGNORED;
	}
	
	set_cd(cd_handle, CD_flNextAttack, halflife_time() + 0.001 );
	
	return FMRES_HANDLED;
}

public fwKilled( id ){
	if( !is_user_connected( id ) ){
		return HAM_IGNORED;
	}
	
	silentGlock[ id ] = false;
	
	return HAM_IGNORED;
}

public fwDrop( iGlock ){
	if( !pev_valid( iGlock ) ){
		return HAM_IGNORED;
	}
	
	new id = get_pdata_cbase(iGlock, m_pPlayer, XO_WEAPON);
	
	if( !is_user_connected( id ) ){
		return HAM_IGNORED;
	}
	
	silentGlock[ id ] = false;
	
	return HAM_IGNORED;
}

public fwRemovePlayerItem( id , iEnt ){
	if ( !is_user_alive( id ) ){
		return HAM_IGNORED;
	}
	
	new iWeapon = cs_get_weapon_id( iEnt );

	if( iWeapon != CSW_GLOCK18 ){
		return HAM_IGNORED;
	}

	silentGlock[ id ] = false;
	
	return HAM_IGNORED;
}

stock setWeaponAnim(id, anim) {
	set_pev(id, pev_weaponanim, anim)
	
	message_begin(MSG_ONE, SVC_WEAPONANIM, {0, 0, 0}, id)
	write_byte(anim)
	write_byte(pev(id, pev_body))
	message_end()
}